<template>
<v-app>
  <form>
      <label>Name</label>
    <v-text-field
      v-model="name"
      :error-messages="nameErrors"
      :counter="10"
      maxlength="10"
      outlined
      required
      @input="$v.name.$touch()"
      @blur="$v.name.$touch()"
    ></v-text-field>
    <label> Qty</label>
    <v-text-field
      v-model="qty"
      :error-messages="qtyErrors"
      :counter="20"
      outlined
      maxlength="20"
      required
      @input="$v.qty.touch()"
      @blur="$v.qty.$touch()"
      ></v-text-field>
    <label>E-maii</label>
    <v-text-field
      v-model="email"
      :error-messages="emailErrors"
      outlined
      required
      @input="$v.email.$touch()"
      @blur="$v.email.$touch()"
    ></v-text-field>
    <label>Item</label>
    <v-select
      v-model="select"
      :items="items"
      :error-messages="selectErrors"
      outlined
      required
      @change="$v.select.$touch()"
      @blur="$v.select.$touch()"
    ></v-select>
    <v-checkbox
      v-model="checkbox"
      :error-messages="checkboxErrors"
      label="Do you agree?"
      required
      @change="$v.checkbox.$touch()"
      @blur="$v.checkbox.$touch()"
    ></v-checkbox>

    <v-btn class="mr-4" @click="submit">submit</v-btn>
    <v-btn @click="clear">clear</v-btn>
  </form>
</v-app>
</template>

<script>
  import { validationMixin } from 'vuelidate'
  import { required, maxLength, email,numeric } from 'vuelidate/lib/validators'

  export default {
      //TODO: mixins意味が分かってない
    mixins: [validationMixin],

    validations: {
      name: { required, maxLength: maxLength(10) },
      email: { required, email },
      select: { required },
      qty:{required,numeric},
      checkbox: {
        checked (val) {
          return val
        },
      },
    },

    data: () => ({
      name: '',
      email: '',
      select: null,
      items: [
        'Item 1',
        'Item 2',
        'Item 3',
        'Item 4',
      ],
      qty:0,
      checkbox: false,
    }),

    computed: {
      checkboxErrors () {
        const errors = []
        if (!this.$v.checkbox.$dirty) return errors
        !this.$v.checkbox.checked && errors.push('You must agree to continue!')
        return errors
      },
      selectErrors () {
        const errors = []
        if (!this.$v.select.$dirty) return errors
        !this.$v.select.required && errors.push('Itemは必須項目です')
        return errors
      },
      nameErrors () {
        const errors = []
        if (!this.$v.name.$dirty) return errors
        !this.$v.name.maxLength && errors.push('Nameは10文字以下で入力してください')
        !this.$v.name.required && errors.push('Nameは必須項目です')
        return errors
      },
      emailErrors () {
        const errors = []
        if (!this.$v.email.$dirty) return errors
        !this.$v.email.email && errors.push('E-mailの形式と異なります')
        !this.$v.email.required && errors.push('E-mailは必須項目です')
        return errors
      },
      qtyErrors(){
          const errors = []
          if(!this.$v.qty.$dirty)return errors 
          !this.$v.qty.required && errors.push('Qtyは必須項目です')
          !this.$v.qty.numeric && errors.push('Qtyは半角数値で入力してください')
          return errors

      }
    },

    methods: {
      submit () {
        this.$v.$touch()
      },
      clear () {
        this.$v.$reset()
        this.name = ''
        this.email = ''
        this.select = null
        this.checkbox = false
      },
    },
  }
</script>